<template>
  <div class="home">
    <div class="container">
      <div class="home-head">
        <img @click="burger" src="../assets/images/icons/burger.svg" alt="">
        <label>
          <input type="text" placeholder="Искать на 2Tap…">
        </label>
      </div>
      <div class="home-filter">
        <p>Найдено 56 предложений</p>
        <div class="pointer">
          <img @click="hideFilters" src="../assets/images/icons/filters.png" alt="">
        </div>
      </div>
    </div>
    <div class="home-filter-slide">
      <div
        v-for="(slide, i) in slideFilter.el"
        :key="i"
        :class="{'active': slideFilter.active === slide.name}"
        @click="slideFilter.active = slide.name"
        class="slide"
      >{{slide.name}}</div>
    </div>
    <div class="container" style="padding-top: 0">
      <router-link
        v-for="(el,i) in profiles"
        :key="'profile-'+i"
        :to="{name: 'profile', params: {id: el.id, type: el.type}}"
        >
        <CardProfile :name="el.name"/>
      </router-link>
    </div>
    <transition name="v-transition-filter">
      <keep-alive max="5">
        <Filters v-if="filters.active"/>
      </keep-alive>
    </transition>
  </div>
</template>

<script>
import CardProfile from "../components/Card-profile";
import Input from "../components/Input";
import Filters from "../components/Filters";
export default {
  name: 'Home',
  components: {Filters, CardProfile},
  data () {
    return {
      slideFilter: {
        active: 'Все',
        el: [
          { name: 'Все', link: '' },
          { name: 'VK', link: '' },
          { name: 'Telegram', link: '' },
          { name: 'Inst', link: '' },
          { name: 'FB', link: '' },
          { name: 'YouTube', link: '' },
          { name: 'Яндекс.Дзен', link: '' },
        ]
      },
      filters: {
        active: false
      },
      profiles: [
        {id: 'JenskiiClub', name: 'Jenskii Club', type: 'option_1'},
        {id: 'UIUXSeniorDesigner', name: 'UI/UX Senior Designer', type: 'option_2'}
      ],
    }
  },
  created () {
    this.$root.$refs.home = this
  },
  methods: {
    burger () {
      this.$root.$refs.app.burgerActive()
    },
    hideFilters () {
      // при открытии меню, нужно проверить прокрутку body
      // если крутится - открыть меню и заблокировать скролл
      if (document.body.style.overflow === '' || document.body.style.overflow === 'visible' && !this.filters.active) {
        document.body.style.overflow = 'hidden'
        this.filters.active = true
      }
      // закрыть меню, только если оно отрыто, так же включить скролл body
      else if (document.body.style.overflow === 'hidden' && this.filters.active) {
        this.filters.active = false
        document.body.style.overflow = 'visible'
      }
    }
  }
}
</script>

<style lang="scss">
.home {
  .container {
    .home-head {
      display: flex;
      justify-content: space-between;
      margin-bottom: 14px;
      img {
        margin-right: 24px;
      }
      label {
        height: 34px;
        width: 100%;
        background: #FFFFFF;
        /* Drop Shadow */
        box-shadow: 8px 8px 20px rgba(0, 0, 0, 0.1);
        border-radius: 10px;
        position: relative;
        padding-left: 44px;
        &:before {
          content: '';
          background: url("../assets/images/icons/search.svg");
          position: absolute;
          top: calc(50% - 12px);
          left: 12px;
          width: 24px;
          height: 24px;
        }
        input {
          width: 100%;
          height: 100%;
          border-radius: 10px;
          &::placeholder {
            font-weight: 400;
            font-size: 14px;
            color: #C4C4C4;
          }
        }
      }
    }
    .home-filter {
      display: flex;
      justify-content: space-between;
    }
  }
  .home-filter-slide {
    display: flex;
    overflow-y: scroll;
    -ms-overflow-style: none;  /* IE and Edge */
    scrollbar-width: none;  /* Firefox */
    padding-left: 24px;
    margin-bottom: 16px;
    &::-webkit-scrollbar {
      display: none;
    }
    .slide {
      margin: 0 8px;
      display: inline-block;
      color: #C4C4C4;
      transition: all 0.3s;
      &:first-child {
        margin-left: 0;
      }
      &.active {
        color: #2B7FE2;
      }
    }
  }
}
.v-transition-filter-enter {
  transform: translate(0, 350px);
  opacity: 0;
}
.v-transition-filter-enter-active {
  transition: all .4s ease;
}
.v-transition-filter-enter-to {
  opacity: 1;
}
.v-transition-filter-leave {
  height: 250px;
  opacity: 1;
}
.v-transition-filter-leave-active {
  transition: transform .4s ease, opacity .4s, height .4s .2s;
}
.v-transition-filter-leave-to {
  height: 0;
  transform: translate(0, 350px);
  opacity: 0;
}
.v-transition-filter-move {
  transition: transform .4s;
}
</style>
